
define(
  [
    'app',
    'html/trolley/trolley_fly',
    'components/view-slidebox/view_slidebox',
    'components/view-grid/view_grid',
    'components/view-broad/view_broad',
    'utils/toastUtil',
    'models/model_activity',
    'components/view-progress/view_progress',
    'html/trolley/trolley_service',
    'components/view-text-scoller/view_text_scoller',
    'html/common/storage',
    'components/view-countdown/view_countdown',
    'models/model_goods'
  ],
  function(app,funParabola){
    'use strict';
    app
      .controller('MainPageController',['$scope','$state','ToastUtils','ActivityModel','trolleyInfo','Storage','GoodsModel','$timeout','$stateParams','$ionicPopup','$ionicSlideBoxDelegate',
        function($scope,$state,ToastUtils,ActivityModel,trolleyInfo,Storage,GoodsModel,$timeout,$stateParams,$ionicPopup,$ionicSlideBoxDelegate){
            function showInfo(){
                if(Storage.get('user_info')==1){
                    $ionicPopup.confirm({
                        title: '是否前往完善信息？',
                        cancelText: '取消',
                        cancelType: 'button-default',
                        okText: '确定',
                        okType: 'button-assertive'
                    }).then(function(res) {
                        Storage.remove('user_info');
                        if (res) {
                            $state.go('userDetail');
                        } else {

                        }
                    })
                }
            }


        getBanner();
        //获取广告图
        function getBanner() {
           ActivityModel.getBanner(function(xhr, re) {
              var code = re.code;
              if (code == 0) {
                  $scope.slides = re.data;
              } else {
                  ToastUtils.showMsgWithCode(code, re.msg);
              }
          }, function(response, data) {
              ToastUtils.showMsgWithCode(7, '获取广告图失败：' + '状态码：' + response.status);
          },null)
        }

        $scope.grids = [
          {
            title:'分类',
            href : '#/classification',
            img : 'img/i1.png'
          },
          {
            title:'10元专区',
            href : '#/tenYuan',
            img : 'img/i2.png'
          },
          {
            title:'晒单',
            href : '#/shareOrder/所有/所有/所有晒单',
            img : 'img/i3.png'
          },
          {
            title:'常见问题',
            href : '#/question/question',
            img : 'img/i4.png'
          }

        ];

       
        
        
        //

        $scope.getLuckyData = [];
        
        //获取最近中奖消息
        function getLuckyData_1() {
           ActivityModel.getluckyInfo(function(xhr, re) {
              var code = re.code;
              if (code == 0) {
                  $scope.getLuckyData = [];
                  $timeout(function() {
                    $scope.getLuckyData = re.data;
                  })
                  
              } else {
                  ToastUtils.showMsgWithCode(code, re.msg);
              }
          }, function(response, data) {
              ToastUtils.showMsgWithCode(7, '获取最近中奖消息失败：' + '状态码：' + response.status);
          },null)
        }
        
        function initConfig() {
          $scope.isLoadFinished = true;
          $scope.pageConfig = [{
            index:1,
            isLoading:false,
            data:[],
            goods_type_id:'',
            order_key:'weight',   //类别
            oder_type:'',
            activity_type:0,//1、非10元；2、10元；3、限购
            emptyData:false,
            page:0,
            pageOver:false,
            pageCount:20
          }]
          getLuckyData_1();
          getHotGoods()
          $scope.getData(true)
        }
        
        $scope.doRefresh = function(){
          initConfig()
        };

        $scope.timeoutCallback = function(activity) {
          GoodsModel.getGoodsDetail(activity.activity_id,function(response, data) {
              if(data.code == 0) {
                var newActivity = data.data;
                activity.status = newActivity.status;
                activity.lucky_unick = newActivity.lucky_unick;
                activity.lucky_num = newActivity.lucky_num;
                activity.lucky_user_num = newActivity.lucky_user_num;
                activity.lucky_ip = newActivity.lucky_ip;

                if($scope.getHomeNewPublishTimeOut) $timeout.cancel($scope.getHomeNewPublishTimeOut);
                $scope.getHomeNewPublishTimeOut = $timeout(function() {
                  getHomeNewPublish()
                },10000)
              }
          });
          
        };

        function getHomeNewPublish() {
           ActivityModel.getHomeNewPublish(function(xhr, re) {
              var code = re.code;
              if (code == 0) {
                  $scope.newPublish = re.data;
                  $timeout(function() {
                    var mySwiper = new ionic.views.Swiper('.js-new-goods', {
                      // height: 189,//你的slide高度
                      slidesPerView : 3,
                      slidesPerGroup : 1,
                    })
                  })
              } else {
                  ToastUtils.showMsgWithCode(code, re.msg);
              }
          }, function(response, data) {
              ToastUtils.showMsgWithCode(7, '获取最新揭晓失败：' + '状态码：' + response.status);
          })
        }
       

        function getHotGoods() {
           ActivityModel.getHotGoods(function(xhr, re) {
              var code = re.code;
              if (code == 0) {
                  $scope.hotGoods = re.data;
                  var cartList = trolleyInfo.getGoodsInfo();
                  dealCartStutas($scope.hotGoods,cartList)
                  $timeout(function() {
                    var mySwiper = new ionic.views.Swiper('.js-hot-goods', {
                      // height: 189,//你的slide高度
                      slidesPerView : 3,
                      slidesPerGroup : 1,
                    })
                  })
              } else {
                  ToastUtils.showMsgWithCode(code, re.msg);
              }
          }, function(response, data) {
              ToastUtils.showMsgWithCode(7, '获取今日热门商品失败：' + '状态码：' + response.status);
          },function() {
            $scope.$broadcast('scroll.refreshComplete');
          })
        }


        $scope.changeActive = function(order_key,order_type,config) {
          if(!$scope.isLoadFinished) return;
          config.order_key = order_key;
          config.isLoading = true;
          if(order_type == 'none') {
            config.order_type = '';
          } else if(order_type == 'asc') {
            config.order_type = 'desc';
          } else {
            config.order_type = 'asc';
          }
          config.page = 0;
          config.data = [];
          $scope.getData(true);
          

        }
        $scope.getMoreData = function() {
          if($scope.pageConfig[0].isLoading) return;
          $scope.getData()
        }
        $scope.getData = function(doRefresh) {
            var postData = $scope.pageConfig[0];
            postData.isLoading = true;
            postData.page++
            ActivityModel.getActivityList(null,null,postData.order_key, postData.order_type,(postData.page - 1) * postData.pageCount + 1,postData.pageCount,'0',postData.activity_type, function(xhr, re) {
               var code = re.code;
               if (code == 0) {
                  var data = re.data;
                  var len = data.length;
                  for(var i = 0;i < len;i++) {
                    postData.data.push(data[i]);
                  }
                  if(len == postData.pageCount) {
                    postData.pageOver = false;
                  } else {
                    postData.pageOver = true;
                  }
                  $scope.$broadcast('scroll.infiniteScrollComplete');
                  var cartList = trolleyInfo.getGoodsInfo();
                  dealCartStutas($scope.pageConfig[0].data,cartList)
               } else {
                   ToastUtils.showMsgWithCode(code, re.msg);
               }
               
           }, function(response, data) {
               ToastUtils.showMsgWithCode(7, '获取商品列表失败：' + '状态码：' + response.status);
           }, function() {
              postData.isLoading = false;
              if(doRefresh) $scope.$broadcast('scroll.refreshComplete');
              // $scope.$broadcast('scroll.infiniteScrollComplete');
           })
       }



       
       
        $scope.getPercentageProgress = function(remain_num,need_num){
          return Math.round((need_num - remain_num) * 100 / need_num);
        };

        function addToCart(broad,$event,type){
          var img = new Image();
          img.src = broad.goods_img;
          img.style.display = 'none';
          img.className = 'eleFlyElement';
          img.style.top = $event.y + 'px';
          img.style.left = $event.x  + 'px';
          angular.element(document.body).append(img);
          img.style.display = 'block';
          var myParabola = funParabola(img, document.querySelector(".js-tab-cart"), {
            speed: 300, //抛物线速度
            curvature: 0.0008, //控制抛物线弧度
            complete: function() {
              img.style.display = 'none';
              angular.element(img).remove()
              var shopItem = broad;
              shopItem.join_number = 1;
              $scope.$apply(function() {
                trolleyInfo.addGoodsItem(shopItem);
                console.log(trolleyInfo.getGoodsInfo()) 
                var cartList = trolleyInfo.getGoodsInfo();
                if(type == 'hotGoods') {
                  dealCartStutas($scope.hotGoods,cartList)
                } else {
                  dealCartStutas($scope.pageConfig[0].data,cartList)
                }
                
                
              })
            }
          });

          myParabola.position().move(); 

          
        };

        function dealCartStutas(goodsList,cartList) {
          goodsList = goodsList || [];
          cartList = cartList || [];
          var goodsLen = goodsList.length || 0;
          var cartLen = cartList.length || 0;
          if(goodsLen == 0 ) return;
          outer:for(var i = 0;i < goodsLen;i++) {
            for(var j = 0;j < cartLen;j++) {
              if(goodsList[i].activity_id == cartList[j].activity_id) {
                goodsList[i].isInCart = true;
                continue outer;
              }
            }
            goodsList[i].isInCart = false;
          } 

        }
        $scope.addToCart = addToCart;

        $scope.goNext = function(){
          $state.go('tab.publish');
        };

        $scope.gotoDetail = function(id){
          $state.go('activity-goodsDetail', {activityId:id});
        };

       initConfig();
        $scope.$on('$ionicView.beforeEnter', function(ev, data) {
             // initConfig();
            getHomeNewPublish(),
            showInfo()
            var cartList = trolleyInfo.getGoodsInfo();
            dealCartStutas($scope.hotGoods,cartList)
            dealCartStutas($scope.pageConfig[0].data,cartList)
	    $timeout(function() {
              $ionicSlideBoxDelegate.next();
            },1000)
            
        })

        $scope.$on('$destroy', function() {
            if($scope.getHomeNewPublishTimeOut) $timeout.cancel($scope.getHomeNewPublishTimeOut);
        });

       
    }]);
});

