/**
 * Created by luliang on 2016/1/20.
 */
define([
  'app',
  'utils/toastUtil',
  'models/model_app',
  'components/view-list-view/view_list_view'
],function(app){
  app.controller('PayResultController',['$scope','$location','$stateParams','$window','AppModel','ToastUtils','$ionicHistory','$state',
    function($scope,$location,$stateParams,$window,AppModel,ToastUtils,$ionicHistory,$state){

    var oderNum;
    var _interval_check;
    $scope.refreshOrderInfo = startCheck;
    $scope.goBack = goBack;
    $scope.goToLatestItem = goToLatestItem;
    $scope.goToMyRedPacket = goToMyRedPacket;
    function initial(){
      getInData();
      startCheck();
    }
    function getInData(){
      oderNum = $stateParams.oderNum;
    }

    function goBack(){
      $ionicHistory.goBack(-3);
    }

    function startCheck(){
      _interval_check = setTimeout(function(){
        refreshOrderInfo();
        startCheck();
      }, 3000);
    }

    function stopCheck(){
      if(_interval_check){
        clearTimeout(_interval_check);
        _interval_check = undefined;
      }
    }

    function isContinueCheck(dataResult){
      if(!dataResult || dataResult.length <= 0){
        return true;
      }else{
        stopCheck();
        return false;
      }
    }

    function refreshOrderInfo(){
      ToastUtils.showLoading('正在获取信息……');
      AppModel.getOrderResult(oderNum,function(response,data){
        var code = data.code;
        if(0 == code){
          var dataResult = data.data;
          if(isContinueCheck(dataResult)){
          }else{
            $scope.packet_stat = data.packet_stat;
            $scope.oderArray = dataResult;
            cacl(dataResult)
          }
        }else{
          ToastUtils.showError('获取号码失败：'+data.msg );
        }
      },function(response,data){
        ToastUtils.showError('网络异常：'+"请检查网络，再重新刷新一下");
      },function(){
        $scope.$broadcast('scroll.refreshComplete');
        ToastUtils.hideLoading();
      });
    }

    function cacl(oderArray) {
        var lose = true;
        $scope.succNum = 0;
        $scope.failNum = 0;
        for(var i = 0,len = oderArray.length;i < len;i++) {
            if(oderArray[i].total > 0) lose = false;
            $scope.succNum += oderArray[i].total;
            if(oderArray[i].no_use_money) {
                $scope.failNum += oderArray[i].no_use_money;
            }
        }
        $scope.fail = lose;
    }
    function goToLatestItem(activityId){
      // $location.path('/goodsDetail/'+activityId).replace();
      $state.go('activity-goodsDetail',{
        activityId:activityId
      })
    }

    function goToMyRedPacket(){
      // $location.path('/redPacket').replace();
      $state.go('redPacket')
    }

    $scope.continueBuy = function(){
      // $location.path('/tab/mainpage').replace();
      $state.go('tab.mainpage')
    };

    $scope.$on('$destroy', function() {
      stopCheck();
      ToastUtils.hideLoading();
    });

    // $scope.oderArray = [
    //           {
    //                  activity_id:87,
    //                  total:20,
    //                  status:1,
    //                  activity_num:[
    //                         "10000758",
    //                         "10000982",
    //                         "10000691",
    //                         "10000970",
    //                         "10000872",
    //                         "10000978",
    //                         "10000699",
    //                         "10000551",
    //                         "10000739",
    //                         "10000770",
    //                         "10000677",
    //                         "10000633",
    //                         "10000535",
    //                         "10000918",
    //                         "10000523",
    //                         "10000846",
    //                         "10000674",
    //                         "10000796",
    //                         "10000773",
    //                         "10000675"
    //                  ],
    //                  goods_title:"Mustang 2016款 2.3T 运动版 涡轮增压 314马力"
    //           },
    //           {
    //                  activity_id:147,
    //                  total:50,
    //                  status:1,
    //                  activity_num:[
    //                         "10000250",
    //                         "10000093",
    //                         "10000058",
    //                         "10000091",
    //                         "10000231",
    //                         "10000040",
    //                         "10000247",
    //                         "10000255",
    //                         "10000147",
    //                         "10000114",
    //                         "10000108",
    //                         "10000006",
    //                         "10000193",
    //                         "10000243",
    //                         "10000171",
    //                         "10000237",
    //                         "10000012",
    //                         "10000159",
    //                         "10000100",
    //                         "10000110",
    //                         "10000028",
    //                         "10000087",
    //                         "10000098",
    //                         "10000107",
    //                         "10000026",
    //                         "10000256",
    //                         "10000129",
    //                         "10000163",
    //                         "10000061",
    //                         "10000002",
    //                         "10000022",
    //                         "10000151",
    //                         "10000212",
    //                         "10000096",
    //                         "10000125",
    //                         "10000148",
    //                         "10000146",
    //                         "10000056",
    //                         "10000267",
    //                         "10000018",
    //                         "10000241",
    //                         "10000236",
    //                         "10000130",
    //                         "10000242",
    //                         "10000025",
    //                         "10000014",
    //                         "10000119",
    //                         "10000221",
    //                         "10000140",
    //                         "10000220"
    //                  ],
    //                  goods_title:"网易云音乐车载mp3蓝牙播放器"
    //           },
    //           {
    //                  activity_id:137,
    //                  total:1,
    //                  status:1,
    //                  activity_num:[
    //                         "10001057"
    //                  ],
    //                  goods_title:"海尔卡萨帝冰箱BCD  435WDCA"
    //           },
    //           {
    //                  activity_id:142,
    //                  total:4,
    //                  status:1,
    //                  activity_num:[
    //                         "10001435",
    //                         "10001412",
    //                         "10001065",
    //                         "10001450"
    //                  ],
    //                  goods_title:"Panasonic松下 HC-MDH2GK MDH2"
    //           },
    //           {
    //                  activity_id:106,
    //                  total:1,
    //                  status:1,
    //                  activity_num:[
    //                         "10000966"
    //                  ],
    //                  goods_title:"【中国黄金】Au9999金砖50g薄片投资金条"
    //           },
    //           {
    //                  activity_id:139,
    //                  total:1,
    //                  status:3,
    //                  activity_num:[
    //                         "10001057"
    //                  ],
    //                  goods_title:"海尔卡萨帝冰箱BCD  435WDCA"
    //           },
    //           {
    //                  activity_id:139,
    //                  total:1,
    //                  status:2,
    //                  activity_num:[
    //                         "10001057"
    //                  ],
    //                  goods_title:"海尔卡萨帝冰箱BCD  435WDCA"
    //           }
    //    ]

    initial();

  }]);
});
